#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <SPI.h>
#include <RFID.h>

#define SS_PIN 10
#define RST_PIN 9
LiquidCrystal_I2C lcd(0x27,16,2);  
RFID rfid(SS_PIN, RST_PIN);
String rfidCard;

int f1=0,f2=0,f3=0;
int c1=0,c2=0,c3=0;
int ok = 0, plataOK = 0, activ = 0;
float sum = 0;
byte Heart[] = {
  B00000,
  B01010,
  B11111,
  B11111,
  B01110,
  B00100,
  B00000,
  B00000
};

byte Car[] = {
  B00000,
  B00000,
  B01111,
  B11111,
  B11111,
  B01001,
  B00000,
  B00000
};

void setup()
{
  lcd.init();                      
  lcd.backlight();
  lcd.createChar(0, Heart);
  lcd.createChar(1, Car);
  lcd.setCursor(0,0);
  lcd.print("Bine ati venit!");
  lcd.setCursor(4,1);
  lcd.print("ECO POWER");
  lcd.setCursor(3,1);
  lcd.write(0);
  lcd.setCursor(13,1);
  lcd.write(1);
  delay(5000);
  lcd.clear();
  
  lcd.setCursor(0,0);
  lcd.print("Apropiati");
  lcd.setCursor(5,1);
  lcd.print("CARDUL");

  
  Serial.begin(9600);
  SPI.begin();
  rfid.init();
}


void loop()
{
  if (rfid.isCard()) {
    if (rfid.readCardSerial()) {
      if(rfid.serNum[0] == 131 && rfid.serNum[1] == 68 && rfid.serNum[2] == 160 && rfid.serNum[3] == 26){
      lcd.setCursor(0,0);
      lcd.print("Card ACCEPTAT!");
      lcd.setCursor(0,1);
      lcd.print("PARCARE: 2 lei");
      delay(5000);
      lcd.clear();
      ok = 1;
      } else {
      lcd.setCursor(0,0);
      lcd.print("Card INVALID!");
      }
    }
    rfid.halt();
  }
int s1=analogRead(A0);
int s2=analogRead(A1);
int s3=analogRead(A2);
if(ok == 1 && plataOK == 0){
lcd.setCursor(0,0);
lcd.print("M50   M10   M5");

if(s1 >= 200 && f1 == 0)
{
  f1=1;
}
else if(s1 < 200 && f1 == 1)
{
  f1 = 0;
  c1++; 
  sum += 0.5;
}


if(s2 >= 200 && f2 == 0)
{
  f2 = 1;
}
else if(s2 < 200 && f2 == 1)
{
  f2 = 0;
  c2++;
  sum += 0.10;
}


if(s3 >= 200 && f3 == 0)
{
  f3 = 1;
}
else if(s3 < 200 && f3 == 1)
{
  f3 = 0;
  c3++;
  sum += 0.05;
}

lcd.setCursor(1,1);
lcd.print(c1);
lcd.setCursor(7,1);
lcd.print(c2);
lcd.setCursor(13,1);
lcd.print(c3);


if(sum >= 2){
 plataOK = 1;
 lcd.clear();
}

}
if(plataOK == 1 && activ == 0){
   lcd.setCursor(0,0);
   lcd.print("Incarcare ACTIVA");
   activ = 1;
   delay(6000);
   lcd.clear();
}
if(activ == 1){
   lcd.setCursor(0,0);
   lcd.print("Timp expirat");
   lcd.setCursor(0,1);
   lcd.print("Va multumim!");
}
}
